<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:template name="ValidContainerNum">
		<xsl:param name="Nums"/>
		<xsl:variable name="Sing0" select="string-length($Nums)&lt;18"/>
		<xsl:variable name="Sing1" select="substring($Nums,1,4)"/>
		<xsl:variable name="Sing2" select="substring($Nums,5)"/>
		<xsl:variable name="Sing11" select="translate($Sing1,'QWERTYUIOPASDFGHJKLMNBVCXZ','AAAAAAAAAAAAAAAAAAAAAAAAAA')"/>
		<xsl:variable name="Sing21">
			<xsl:choose>
				<xsl:when test="number($Sing2)!='NaN'">
					<xsl:value-of select="translate($Sing2,'0123456789', '9999999999')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$Sing2"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$Sing0 and $Sing11='AAAA' and $Sing21='9999999'">1</xsl:when>
			<xsl:otherwise>0</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="ValidInnCee">
		<xsl:param name="INN"/>
		<xsl:variable name="N1" select="number(substring($INN,1,1))"/>
		<xsl:variable name="N2" select="number(substring($INN,2,1))"/>
		<xsl:variable name="N3" select="number(substring($INN,3,1))"/>
		<xsl:variable name="N4" select="number(substring($INN,4,1))"/>
		<xsl:variable name="N5" select="number(substring($INN,5,1))"/>
		<xsl:variable name="N6" select="number(substring($INN,6,1))"/>
		<xsl:variable name="N7" select="number(substring($INN,7,1))"/>
		<xsl:variable name="N8" select="number(substring($INN,8,1))"/>
		<xsl:variable name="N9" select="number(substring($INN,9,1))"/>
		<xsl:variable name="N10" select="number(substring($INN,10,1))"/>
		<xsl:variable name="N11" select="number(substring($INN,11,1))"/>
		<xsl:choose>
			<xsl:when test="number($INN)">
				<xsl:choose>
					<xsl:when test="string-length($INN)=10">
						<xsl:variable name="Nsum" select="(($N1 * 2+$N2 * 4+$N3 * 10+$N4 * 3+$N5 * 5+$N6 * 9+$N7 * 4+$N8 * 6+$N9 * 8) mod 11) mod 10"/>
						<xsl:choose>
							<xsl:when test="(number(substring($INN,10,1))=$Nsum)">0</xsl:when>
							<xsl:otherwise>1</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="string-length($INN)=12">
						<xsl:variable name="Nsum1" select="($N1 * 7+$N2 * 2+$N3 * 4+$N4 * 10+$N5 * 3+$N6 * 5+$N7 * 9+$N8 * 4+$N9 * 6+$N10 * 8) mod 11"/>
						<xsl:variable name="Nsum2" select="($N1 * 3+$N2 * 7+$N3 * 2+$N4 * 4+$N5 * 10+$N6 * 3+$N7 * 5+$N8 * 9+$N9 * 4+$N10 * 6+$N11 * 8) mod 11"/>
						<xsl:variable name="K1Sum">
							<xsl:choose>
								<xsl:when test="$Nsum1 >9">
									<xsl:value-of select="$Nsum1 mod 10"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$Nsum1"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:variable name="K2Sum">
							<xsl:choose>
								<xsl:when test="$Nsum2>9">
									<xsl:value-of select="$Nsum2 mod 10"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$Nsum2"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:choose>
							<xsl:when test="(number(substring($INN,11,1))=number($K1Sum) and number(substring($INN,12,1))=number($K2Sum))">0</xsl:when>
							<xsl:otherwise>1</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>1</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="VagonRwFlk">
		<xsl:param name="NumVagon"/>
		<xsl:param name="RwbType"/>
		<xsl:param name="RwbPos"/>
		<xsl:param name="NodeRw"/>
		<xsl:param name="Pos"/>
		<xsl:param name="Flg"/>
		<xsl:if test="(string-length(GoodsWeight)=0 or number(GoodsWeight)=0) and number(../../GrossWeightQuantity)>0">
			<xsl:call-template name="ErrorNode">
				<xsl:with-param name="MessErr" select="'Пакет содержит документ СМГС с вагоном, у которого не заполнено или заполнено не верно поле Вес груза в вагоне .'"/>
				<xsl:with-param name="DocId" select="../../../@id"/>
				<xsl:with-param name="PathErr" select="concat('RWB/RWB_ITEM/',$NodeRw,'[',$Pos,']/GoodsWeight')"/>
				<xsl:with-param name="TypeDoc" select="$RwbType"/>
				<xsl:with-param name="PosPkg" select="$RwbPos"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$Flg=0">
				<xsl:if test="string-length($NumVagon)=7 and string-length(CarriageLand)=0">
					<xsl:call-template name="ErrorNode">
						<xsl:with-param name="MessErr" select="'Пакет содержит документ СМГС с вагоном, у которого не заполнено поле Код страны собственника.'"/>
						<xsl:with-param name="DocId" select="../../../@id"/>
						<xsl:with-param name="PathErr" select="concat('RWB/RWB_ITEM/',$NodeRw,'[',$Pos,']/CarriageLand')"/>
						<xsl:with-param name="TypeDoc" select="$RwbType"/>
						<xsl:with-param name="PosPkg" select="$RwbPos"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$Flg=1">
				<xsl:if test="string-length($NumVagon)=7 and string-length(WOWNER)=0">
					<xsl:call-template name="ErrorNode">
						<xsl:with-param name="MessErr" select="'Пакет содержит документ СМГС с вагоном в вагонной ведомости, у которого не заполнено поле Код страны собственника.'"/>
						<xsl:with-param name="DocId" select="../../../@id"/>
						<xsl:with-param name="PathErr" select="concat('RWB/RWB_ITEM/',$NodeRw,'[',$Pos,']/WOWNER')"/>
						<xsl:with-param name="TypeDoc" select="$RwbType"/>
						<xsl:with-param name="PosPkg" select="$RwbPos"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="ErrorNode">
		<xsl:param name="MessErr"/>
		<xsl:param name="DocId"/>
		<xsl:param name="PathErr"/>
		<xsl:param name="Category"/>
		<xsl:param name="Num"/>
		<xsl:param name="TypeDoc"/>
		<xsl:param name="PosPkg"/>
		<xsl:variable name="Cat">
			<xsl:choose>
				<xsl:when test="string-length($Category)=0">ERROR</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$Category"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<RESULTINFORMATION_ITEM xmlns:ctmtd="http://rail.ctm.ru/TD/Document">
			<ResultDescription><xsl:value-of select="$MessErr"/></ResultDescription>
			<ResultIdDocument><xsl:value-of select="$DocId"/></ResultIdDocument>
			<ResultTypeDocument><xsl:value-of select="$TypeDoc"/></ResultTypeDocument>
			<ResultPosInPkgDocument><xsl:value-of select="$PosPkg"/></ResultPosInPkgDocument>
			<ResultPathNode><xsl:value-of select="$PathErr"/></ResultPathNode>
			<ResultCategory><xsl:value-of select="$Cat"/></ResultCategory>
			<DocumentNumber><xsl:value-of select="$Num"/></DocumentNumber>
		</RESULTINFORMATION_ITEM>	
	</xsl:template>
	<xsl:template name="UpperCaseRus">
		<xsl:param name="string"/>
		<xsl:variable name="smallcase" select="'йцукенгшщзхъёфывапролджэячсмитьбю'"/>
		<xsl:variable name="uppercase" select="'ЙЦУКЕНГШЩЗХЪЁФЫВАПРОЛДЖЭЯЧСМИТЬБЮ'"/>
		<xsl:value-of select="translate($string, $smallcase, $uppercase)"/>
	</xsl:template>
</xsl:stylesheet>
