<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="../../../COMMON/FunctionForArmtyXsl.xsl"/>

	<xsl:import href="DesNotif_PIResult.FLKSea.xsl"/>
	<xsl:output method="xml"/>
	<xsl:param name="ConosamentFromArrSeaDcl"/>	
	<xsl:param name="AllFlk"/>
	<xsl:template name="ValidContainerNum">
		<xsl:param name="Nums"/>
		<xsl:variable name="Sing0" select="string-length($Nums)&lt;18"/>
		<xsl:variable name="Sing1" select="substring($Nums,1,4)"/>
		<xsl:variable name="Sing2" select="substring($Nums,5)"/>
		<xsl:variable name="Sing11" select="contains(translate($Sing1,'QWERTYUIOPLKJHGFDSAZXCVBNM','AAAAAAAAAAAAAAAAAAAAAAAAA'),'A')"/>
		<xsl:variable name="Sing21">
			<xsl:choose>
				<xsl:when test="number($Sing2)=$Sing2 and contains(translate($Sing2,'0123456789', '9999999999'),'9')">1</xsl:when>
				<xsl:otherwise>0</xsl:otherwise>
			</xsl:choose> 
		</xsl:variable> 
		<xsl:choose>
			<xsl:when test="$Sing0 and $Sing11 and number($Sing21)=1">1</xsl:when>
			<xsl:otherwise>0</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="ErrorNode">
		<xsl:param name="MessErr"/>
		<xsl:param name="DocId"/>
		<xsl:param name="PathErr"/>
		<xsl:param name="Category"/>
		<xsl:param name="Num"/>
		<xsl:variable name="Cat">
			<xsl:choose>
				<xsl:when test="string-length($Category)=0">ERROR</xsl:when>
				<xsl:otherwise><xsl:value-of select="$Category" /></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<RESULTINFORMATION_ITEM>
			<ResultDescription><xsl:copy-of select="$MessErr"/></ResultDescription>
			<ResultIdDocument><xsl:value-of select="$DocId"/></ResultIdDocument>
			<ResultPathNode><xsl:value-of select="$PathErr"/></ResultPathNode>
			<ResultCategory><xsl:value-of select="$Cat"/></ResultCategory>
			<DocumentNumber><xsl:value-of select="$Num"/></DocumentNumber>
		</RESULTINFORMATION_ITEM>	
	</xsl:template>

	<xsl:template match="/">
		<xsl:apply-templates select="//Package"/>
	</xsl:template>

		
	<xsl:template match="Package">
		<ResultInformation>
			<xsl:call-template name="FlkSea">
				<xsl:with-param name="ConosamentFromArrSeaDcl" select="$ConosamentFromArrSeaDcl" />	
				<xsl:with-param name="AllFlk" select="$AllFlk"/>
			</xsl:call-template>
		</ResultInformation>
	</xsl:template>
</xsl:stylesheet>
